typedef enum {   
	// source_a_set()
                                                source_for_a_picture_   = 0l,
                                                source_for_a_host_     = 1l,
                                                source_for_a_video_    = 2l,
                                                source_for_a_video1_   = 3l,

   // source_b_set()
                                                source_for_b_picture_  = 0l,
                                                source_for_b_host_     = 1l,
                                                source_for_b_video_    = 2l,
                                                source_for_b_module_   = 3l,

   // source_alpha_set()
                                                source_for_alpha_picture_  = 0l,
                                                source_for_alpha_host_     = 1l,

   // writebank_a_set()
                                                write_a_hard_          = 0l,
                                                write_a_inverse_       = 1l,
                                                write_a_0_             = 2l,
                                                write_a_1_             = 3l,

   // readbank_a_set()
                                                read_a_hard_           = 0l,
                                                read_a_inverse_        = 1l,
                                                read_a_0_              = 2l,
                                                read_a_1_              = 3l,

   // writebank_b_set()
                                                write_b_hard_          = 0l,
                                                write_b_inverse_       = 1l,
                                                write_b_0_             = 2l,
                                                write_b_1_             = 3l,


   // readbank_b_set()
                                                read_b_hard_           = 0l,
                                                read_b_inverse_        = 1l,
                                                read_b_0_              = 2l,
                                                read_b_1_              = 3l,

   // writebank_alpha_set()
                                                write_alpha_hard_      = 0l,
                                                write_alpha_inverse_   = 1l,
                                                write_alpha_0_         = 2l,
                                                write_alpha_1_         = 3l,

   // readbank_alpha_set()
                                                read_alpha_hard_       = 0l,
                                                read_alpha_inverse_    = 1l,
                                                read_alpha_0_          = 2l,
                                                read_alpha_1_          = 3l,

   // mixer_a_set()
                                                mixer_a_a_             = 0l,
                                                mixer_a_black_         = 1l,
                                                mixer_a_grey_          = 2l,
                                                mixer_a_white_         = 3l,

   // mixer_b_set()
                                                mixer_b_b_             = 0l,
                                                mixer_b_module_        = 1l,
                                                mixer_b_black_         = 2l,
                                                mixer_b_white_         = 3l,

   // mixer_alpha_set()
                                                mixer_alpha_           = 0l,
                                                mixer_keyer_           = 1l,

   // mixer_blender_set()
                                                mixer_blender_0_       = 0l,
                                                mixer_blender_1_       = 1l,
                                                mixer_blender_direct_  = 2l,
                                                mixer_blender_inverse_ = 3l,

   // mixer_border_set()
                                                mixer_border_black_    = 0l,
                                                mixer_border_b_        = 1l,


   // key_clipper_set()
                                                key_clipper_0_         = 0l,
                                                key_clipper_1_         = 1l,
                                                key_clipper_2_         = 2l,
                                                key_clipper_3_         = 3l,

   // key_filter_set()
                                                key_filter_narrow_     = 0l,
                                                key_filter_middle_     = 1l,
                                                key_filter_wide_       = 2l,


   // key_mode_set()
                                                key_mode_288_          = 0l,
                                                key_mode_477_          = 1l,
                                                key_mode_666_          = 2l,

// Formats of pixels

                                                rgb_32_packed_          =     0l,
                                                rgb_24_packed_          =     1l,
                                                rgb_15_packed_dither_   =     2l,
                                                rgb_15_packed_          =     3l,
                                                rgb_16_packed_dither_   =     4l,
                                                rgb_16_packed_          =     5l,
                                                gray_8_packed_          =     6l,
                                                yuv_16_packed_          =     7l,
                                                jpeg_packed_            =     8l,

// masks of existing pixel formats

                                                rgb_32_packed_mask_        =  1l,
                                                rgb_24_packed_mask_        =  2l,
                                                rgb_15_packed_dither_mask_ =  4l,
                                                rgb_15_packed_mask_        =  8l,
                                                rgb_16_packed_dither_mask_ =  16l,
                                                rgb_16_packed_mask_        =  32l,
                                                gray_8_packed_mask_        =  64l,
                                                yuv_16_packed_mask_        =  128l,
                                                jpeg_packed_mask_          =  256l,

// video standarts for GRAB_SetStandard(long  vstd),

                                                vstd_secam_                =  0l,
                                                vstd_pal_                  =  1l,
                                                vstd_ntsc_                 =  2l,
                                                vstd_pal_n_50_             =  3l,
                                                vstd_pal_m_60_             =  4l,
                                                vstd_ntsc443_50_           =  5l,
                                                vstd_ntsc443_60_           =  6l,

// masks of existing video standarts in long GRAB_StdCaps for current board after call to GRAB_GrabInit()

                                                vstd_secam_mask_            = 1l,
                                                vstd_pal_mask_              = 2l,
                                                vstd_ntsc_mask_             = 4l,
                                                vstd_pal_n_50_mask_         = 8l,
                                                vstd_pal_m_60_mask_         = 16l,
                                                vstd_ntsc443_50_mask_       = 32l,
                                                vstd_ntsc443_60_mask_       = 64l,

// cable system

                                                vtype_svideo_               = 0l,
                                                vtype_composit_             = 1l,
                                                vtype_component_            = 2l,

// masks of existing cable systems

                                                vtype_svideo_mask_          = 1l,
                                                vtype_composit_mask_        = 2l,
                                                vtype_component_mask_       = 4l,

												wnd_a_						= 1l,
												wnd_b_						= 2l,
												wnd_alpha_					= 4l

} frwdconsts_enum;

[helpstring("Forward Resources bit's numbers in masks")]
typedef enum
{
     rg_bank_a_bit_           = 0,   /* data in bank "A" & mixer input "a" */
     rg_bank_b_bit_           = 1,   /* data in bank "B" & mixer input "b" */
     rg_bank_alpha_bit_       = 2,   /* data in bank "Alpha"               */
     rg_bank_key_bit_         = 3,   /* data in key table                  */
     rg_mixer_bit_            = 4,   /* state of alpha/key mixer           */
     rg_window_bit_           = 5,   /* coordinates of mixer window        */
     rg_live_video_bit_       = 6,   /* live video & input scaler window   */
     rg_play_fifo_bit_        = 7,   /* play video fifo                    */
     rg_input_video_bit_      = 8,   /* input video standart              */
     rg_output_video_bit_     = 9,   /* output video standart              */

     rg_prim_con_bit_         = 31,  /* primery/test console application   */
     rg_sec_con_bit_          = 30,  /* secondary/user console application */
     rg_ioset_con_bit_        = 29   /* io-settings/user console application */
} FrwResourcesBits;

const long ResourcesTotal = 32;
const long rg_bank_a_m_           = (1 << rg_bank_a_bit_);
const long rg_bank_b_m_           = (1 << rg_bank_b_bit_);
const long rg_bank_alpha_m_       = (1 << rg_bank_alpha_bit_);
const long rg_bank_key_m_         = (1 << rg_bank_key_bit_);
const long rg_mixer_m_            = (1 << rg_mixer_bit_);
const long rg_window_m_           = (1 << rg_window_bit_);
const long rg_live_video_m_       = (1 << rg_live_video_bit_);
const long rg_play_fifo_m_        = (1 << rg_play_fifo_bit_);
const long rg_input_video_m_      = (1 << rg_input_video_bit_);
const long rg_output_video_m_     = (1 << rg_output_video_bit_);

const long rg_prim_con_m_         = (1 << rg_prim_con_bit_);
const long rg_sec_con_m_          = (1 << rg_sec_con_bit_);
const long rg_ioset_con_m_        = (1 << rg_ioset_con_bit_);

